### Functions

## PHP magic method to facilitate dynamic methods

    __call(string $name, array $params)

### Parameters

#### $name

`string`

#### $params

`array`

## Magic function called when cloning an object

    __clone()

## Protected constructor for creating the one instance

    __construct()

## PHP magic method that is called when an object is treated as a function

    __invoke(array $params) : \self

### Parameters

#### $params

`array`

### Returns

`\self`

## Prints out the contents of the object when used as a string

    __toString() : string

### Returns

`string`

## Returns routable methods for the specified controller class

    controller_methods(string $controller) : array

### Parameters

#### $controller

`string`

### Returns

`array`

## Filter out db rows into one array

    db_filter(array $array, mixed $index) : array

### Parameters

#### $array

`array`

#### $index

`mixed`

### Returns

`array`

## Bulk directory loading workaround for use with array_map and glob

    do_include(string $path) : void

### Parameters

#### $path

`string`

## Array_map callback to load a folder of classes at once

    do_include(string $path) : void

### Parameters

#### $path

`string`

## Singleton getter function

    get_instance() : \self

### Returns

`\self`

## Utility function to check if a variable is set, and is an array or object

    is_like_array(mixed $var) : bool

### Parameters

#### $var

`mixed`

### Returns

`bool`

## Function to search through the tree to find the necessary file

    load_file(string $file, string $curr_path) : void

### Parameters

#### $file

`string`

#### $curr_path

`string`

## Custom error handler

    on_error(int $severity, string $message, string $filepath, int $line) : \ErrorException

### Parameters

#### $severity

`int`

#### $message

`string`

#### $filepath

`string`

#### $line

`int`

### Returns

`\ErrorException`

## Custom exception handlererror_get_last

    on_exception(\Exception $exception) : void

### Parameters

#### $exception

`\Exception`

## Calls the appropriate module/controller/function based on the url

    route() : void

## General 404 function

    show_404() : void

## Fatal Error page function

    show_error(string $message, int $status_code)

### Parameters

#### $message

`string`

#### $status_code

`int`

## Function to run on script shutdown -used to catch most fatal errors, and display them cleanly

    shutdown() : void

## Returns a full url from a url segment

    site_url(string $segment) : string

### Parameters

#### $segment

`string`

### Returns

`string`

## Prints out the contents of the object

    to_string(\object/array $data, string $method) : string

### Parameters

#### $data

`\object/array`

#### $method

`string`

### Returns

`string`

### Classes and interfaces

# DB¶

Extend PHP's PDO class to add some more functionality

« More »

# DB_PDO¶

Base Database class

« More »

# DB_Reg¶

Connection registry

« More »

# DB_SQL¶

Abstract parent for database manipulation subclasses

« More »

# DB_Util¶

Abstract class defining database / table creation methods

« More »

# Firebird¶

Firebird Database class

« More »

# Firebird_Result¶

Firebird result class to emulate PDOStatement Class - only implements data-fetching methods

« More »

# Firebird_SQL¶

Firebird Specific SQL

« More »

# Firebird_Util¶

Firebird-specific backup, import and creation methods

« More »

# MM¶

Class for standalone JSObject objects

« More »

# MM_Controller¶

Base Controller Class

« More »

# MM_Model¶

Base Model Class

« More »

# MM_Output¶

Class for displaying output and setting http headers

« More »

# MM_Page¶

Class for building pages

« More »

# MM_Session¶

Class to improve handling of PHP sessions

« More »

# MySQL¶

MySQL specific class

« More »

# MySQL_SQL¶

MySQL specifc SQL

« More »

# MySQL_Util¶

MySQL-specific backup, import and creation methods

« More »

# ODBC¶

ODBC Database Driver

« More »

# ODBC_SQL¶

ODBC SQL Class

« More »

# ODBC_Util¶

ODBC-specific backup, import and creation methods

« More »

# PgSQL¶

PostgreSQL specifc class

« More »

# PgSQL_SQL¶

PostgreSQL specifc SQL

« More »

# PgSQL_Util¶

Posgres-specific backup, import and creation methods

« More »

# Query_Builder¶

Convienience class for creating sql queries - also the class that instantiates the specific db driver

« More »

# SQLite¶

SQLite specific class

« More »

# SQLite_SQL¶

SQLite Specific SQL

« More »

# SQLite_Util¶

SQLite-specific backup, import and creation methods

« More »

# Settings¶

Class for manipulating datbase connections, and miscellaneous settings

« More »

# Welcome¶

Example Controller Class

« More »

# Welcome_Model¶

Model template class

« More »

# miniMVC¶

Base class for the framework

« More »

### Constants

## BASE_URL

    BASE_URL

## CONTENT_DOMAIN

    CONTENT_DOMAIN

## DEFAULT_CSS_GROUP

    DEFAULT_CSS_GROUP

## DEFAULT_JS_GROUP

    DEFAULT_JS_GROUP

## DEFAULT_TITLE

    DEFAULT_TITLE

## miniMVC bootstrap file

    ENVIRONMENT

package | miniMVC
subpackage | App

## MM_APP_PATH

    MM_APP_PATH

## MM_BASE_PATH

    MM_BASE_PATH

## MM_MOD_PATH

    MM_MOD_PATH

## MM_SYS_PATH

    MM_SYS_PATH

## Reference to root path

    QBASE_PATH

## Path to driver classes

    QDRIVER_PATH

## SCRIPT_PATH

    SCRIPT_PATH

## Main config file

    SHOW_DEBUG_BACKTRACE

package | miniMVC
subpackage | App

## STATIC_LIB_PATH

    STATIC_LIB_PATH

## STYLE_PATH

    STYLE_PATH

## URL_INDEX_FILE

    URL_INDEX_FILE

## Define a session id to namespace sessions

    Unknown